{*******************************************************************************

Unit Unit1 de GetScanLine

Copyright CNRS
contributeur : Sylvain Mottet (dcembre 2006)

sylvain.mottet @ univ-paris5.fr

Ce logiciel est un programme informatique dmontrant l'appel de la fonction
GetScanLine, l'utilisation de l'interface IDirectDraw et celle des performance
counter de l'API Windows(r).

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilit au code source et des droits de copie,
de modification et de redistribution accords par cette licence, il n'est
offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons,
seule une responsabilit restreinte pse sur l'auteur du programme, le
titulaire des droits patrimoniaux et les concdants successifs.

A cet gard  l'attention de l'utilisateur est attire sur les risques
associs au chargement,  l'utilisation,  la modification et/ou au
dveloppement et  la reproduction du logiciel par l'utilisateur tant
donn sa spcificit de logiciel libre, qui peut le rendre complexe 
manipuler et qui le rserve donc  des dveloppeurs et des professionnels
avertis possdant des connaissances informatiques approfondies. Les
utilisateurs sont donc invits  charger et tester l'adquation du
logiciel  leurs besoins dans des conditions permettant d'assurer la
scurit de leurs systmes et ou de leurs donnes et, plus gnralement,
 l'utiliser et l'exploiter dans les mmes conditions de scurit.

Le fait que vous puissiez accder  cet en-tte signifie que vous avez
pris connaissance de la licence CeCILL, et que vous en avez accept les
termes.

*******************************************************************************}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls,
  DirectDraw;

type
  TForm1 = class(TForm)
    btnGetScanLine: TButton;
    ListBox1: TListBox;
    lblDuration: TLabel;
    edtDuration: TEdit;
    cbProcessMessages: TCheckBox;
    lblcolumns: TLabel;
    procedure btnGetScanLineClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    idd: IDirectDraw;
    duration: Longint;
    temps: array of Integer;
    scanlines: array of Integer;
  end;

var
  Form1: TForm1;

implementation
{$R *.DFM}

uses
  MMTimer2;

procedure TForm1.btnGetScanLineClick(Sender: TObject);
var
  t0, t: Int64;
  sl: DWORD;
  cpt: Integer;
  hr: HResult;
  i: Integer;
  strtemps, strscanline: String;
begin
  duration := StrToInt(edtDuration.Text) * 1000;
  SetLength(temps, duration);
  SetLength(scanlines, duration);
  cpt := 0;
  t0 := GetMicroCounter;
  repeat
    t := GetMicroCounter;
    hr := idd.GetScanLine(sl);
    // enregistre le temps et la scanline en vitant un dbordement si tableau
    // trop petit pour temps trop long...
    if ( cpt < duration ) then
    begin
      temps[cpt] := t - t0;
      scanlines[cpt] := sl;
    end;
    Inc(cpt);
    if ( cbProcessMessages.Checked ) then
      Application.ProcessMessages;
  until ( (t - t0) > duration );

  ListBox1.Items.Clear;
  for i := 0 to cpt - 1 do
  begin
    // formattage des rsultats
    strtemps := IntToStr(temps[i]);
    if ( length(strtemps) > 3 ) then
      strtemps := Copy(strtemps, 1, length(strtemps) - 3) + '.' + Copy(strtemps, Length(strtemps) - 2, MAXINT);
    strtemps := StringOfChar(' ', 10 - Length(strtemps)) + strtemps;
    strscanline := IntToStr(scanlines[i]);
    strscanline := StringOfChar(' ', 4 - length(strscanline)) + strscanline;
    ListBox1.Items.Add(strtemps + ': ' + strscanline);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  DirectDrawCreate(nil, idd, nil);
  ListBox1.Font.Name := 'courier new';
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  idd := nil;
end;

end.
